'''
--------------------------------------------------------------------------------
Specs: given a file like below, find a magic square with non-neg numbers
First line is dimension (n) of square
Next d lines contain the grid. -1 is placeholder for empty, modifiable value
Next line contains n row sums (first number is sum of top row)
Next line contains n col sums (first number is sum of leftmost col)
Next line contains 2 diag sums (first number is top-left to bottom-right)
--------------------------------------------------------------------------------
3
-1 -1 0
5 -1 2
-1 -1 -1
10 8 9
12 10 5
9 3
--------------------------------------------------------------------------------
From the above input, the following would be appropriate output (stdout) 
--------------------------------------------------------------------------------
True
5 5 0
5 1 2
2 4 3
--------------------------------------------------------------------------------
'''

import sys

def read_input(path):
	input_grid = []
	with open(path) as reader:
		size = int(reader.readline().rstrip())

		for i in xrange(size):
			vals = [int(x) for x in reader.readline().rstrip().split(' ')]
			input_grid.append(vals)

		# Do stuff with these
		row_sums = [int(x) for x in reader.readline().rstrip().split(' ')]
		col_sums = [int(x) for x in reader.readline().rstrip().split(' ')]
		diag_sums = [int(x) for x in reader.readline().rstrip().split(' ')]

	return input_grid

def print_result(grid):
	if grid is None:
		print 'False'
	else:
		print 'True'
		for i in xrange(len(grid)):
			grid_str = [str(x) for x in grid[i]]
			print ' '.join(grid_str)

if __name__ == '__main__':
	filename = sys.argv[1]
	grid = read_input(filename)
	print_result(grid)